﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Windows;
using Infragistics.Controls.Grids;

namespace XamGridCheckBoxSelector
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<Person> coll { get; set; }
        
        public MainWindow()
        {
            InitializeComponent();

            coll = new ObservableCollection<Person>();

            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 1, LastName = "Doe" });
            coll.Add(new Person() { Id = 2, LastName = "Doe", Age = 34.5555 });
            coll.Add(new Person() { Id = 3, LastName = "Doe", Age = 56 });
            coll.Add(new Person() { Id = 4, LastName = "Smith", Age = 23 });
            this.DataContext = coll;

        }

        private void CheckBox_Checked(object sender, RoutedEventArgs e)
        {
            int index = ((sender as CheckBox).Tag as RowSelectorCellControl).Cell.Row.Index;            
            xamGrid1.SelectionSettings.SelectedRows.Add(xamGrid1.Rows[index]);
        }

        private void CheckBox_Unchecked(object sender, RoutedEventArgs e)
        {
            if (xamGrid1.SelectionSettings.SelectedRows.Count > 0)
            {
                int index = ((sender as CheckBox).Tag as RowSelectorCellControl).Cell.Row.Index;
                xamGrid1.SelectionSettings.SelectedRows.Remove(xamGrid1.Rows[index]);
            }
            
        }

        private void CheckBox_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            (sender as CheckBox).IsChecked = !(sender as CheckBox).IsChecked;
        }

        private void xamGrid1_CellClicked(object sender, Infragistics.Controls.Grids.CellClickedEventArgs e)
        {
            foreach (var item in xamGrid1.Rows)
            {
                CheckBox cb = Utilities.GetDescendantFromName(item.Control, "checkBox1") as CheckBox;
                cb.IsChecked = false;
            }            
            CheckBox cb1 = Utilities.GetDescendantFromName(e.Cell.Row.Control, "checkBox1") as CheckBox;
            cb1.IsChecked = true;
        }
    }

    public class Person : INotifyPropertyChanged
    {
        private int id;


        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("Id");
            }
        }

        private double age;

        public double Age
        {
            get { return age; }
            set { age = value; NotifyPropertyChanged("Age"); }
        }
        

        private String lastName;

        public String LastName
        {
            get { return lastName; }
            set { lastName = value; NotifyPropertyChanged("LastName"); }
        }

        private bool _selected;
        public bool IsSelected
        {
            get { return _selected; }
            set
            {
                if(_selected != value)
                {
                    _selected = value;
                    NotifyPropertyChanged("IsSelected");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

    }
}
